# -*- coding: utf-8 -*-
"""
Gestiona una ruta GPS

@author: Michael
@date:   abr 2019
"""

from typing import List
from track import Track
# TO-DO: otros imports

class Ruta:
    """
    Clase para gestionar rutas almacenadas en un fichero GPX

    Attributes:
        __latitud: Lista de latitudes
        __longitud: Lista de longitudes
        __elevacion: Lista de elevaciones
    """

    def __init__(self, nombre_fichero: str):
        """
        Constructor que introduce en los atributos los datos de una ruta
        cuyo nombre se pasa como argumento

        Args:
            nombre_fichero: el nombre del fichero de tipo .gpx
        """
        trk = Track(nombre_fichero)
        self.__latitud: List[float] = trk.get_latitudes()
        self.__longitud: List[float] = trk.get_longitudes()
        self.__elevacion: List[float] = trk.get_elevaciones()


    def muestra_perfil(self):
        """
        Metodo que representa en una gráfica el perfil de la ruta, es decir,
        la elevacion de cada punto, en m, frente a la distancia
        recorrida, en km.
        """
    # TO-DO


    def ascenso_acumulado(self)-> float:
        """
        Retorna el ascenso acumulado en metros. El ascenso acumulado suma
        los cambios de elevacion al pasar de un punto de la ruta al siguiente,
        pero solo los que sean positivos

        Returns:
            ascenso acumulado en metros
        """
    # TO-DO


    def pinta_ruta(self, lado: int):
        """
        Método que representa la ruta en una ventana cuadrada cuyo tamano
        se pasa como argumento

        Args:
            lado: lado, en pixels, de la ventana cuadrada en la
                  que se representara la ruta
        """



def main():
    """
    Programa que prueba la clase Ruta
    """
    # TO-DO

if __name__ == "__main__":
    main()
